﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using MySql.Data.MySqlClient;
using System.IO;
using System.Diagnostics;

namespace Denormalizasyon
{
    public partial class Form1 : Form
    {
        string cs = @"server=localhost;userid=root;password=xxxxxxx;database=anket";

        MySqlConnection conn = null;

        public Form1()
        {
            InitializeComponent();
        }

        #region Test İşlemleri
        private void BTN_Olustur_Click(object sender, EventArgs e)
        {
            string[] _anketids = TXT_AnketID.Text.Split('-');
            int ank_bas = Convert.ToInt32(_anketids[0]);
            int ank_bit = Convert.ToInt32(_anketids[1]);

            for (int a = ank_bas; a <= ank_bit; a++)
            {
                tablo_olustur(a);
                sorgulama(a);
            }
        }

        private void tablo_olustur(int anket_no)
        {
            string insert_sql_nor = "INSERT INTO anket_cevap_nor (Anket_ID, Anket_Icerik_ID, Ders_ID, Donem_ID, Cevap) VALUES ";
            string insert_sql_nor_ind = "INSERT INTO anket_cevap_nor_ind (Anket_ID, Anket_Icerik_ID, Ders_ID, Donem_ID, Cevap) VALUES ";           
            string Donem_ID = TXT_DonemID.Text;
            string[] _dersids = TXT_DersIDs.Text.Split('-');
            int ders_bas = Convert.ToInt32(_dersids[0]);
            int ders_bit = Convert.ToInt32(_dersids[1]);
            int anket_sayisi = Convert.ToInt32(TXT_AnketSayisi.Text);
            MySqlCommand cmd = null;
            Stopwatch stopwatch_1 = new Stopwatch();
            Stopwatch stopwatch_2 = new Stopwatch();
            Stopwatch stopwatch_3 = new Stopwatch();

            //int cnt_1 = 0; int cnt_2 = 0; //işlem sayısını tutmak için 100 ve 300 işlemden sonra farklı dosyalara yazılıyor

            //double t_sure1_1 = 0; double t_sure1_2 = 0;
            //int t_kayit1_1 = 0; int t_kayit1_2 = 0;

            int eklenen_1 = 0;
            int eklenen_2 = 0;


            int soru_grp = anket_no % 8;//8  adet farklı sorum olduğu için
            if (soru_grp == 0)
                soru_grp = 8;
            List<string> sorular = Get_Anket_Soru(soru_grp);
            //ders aralığı kadar bir döngü açılıyor.
            for (int i = ders_bas; i <= ders_bit; i++)
            {
                //derse ait anket sayısı
                Random rnd = new Random();
                for (int j = 0; j < anket_sayisi; j++)
                {
                    string temp = "";
                    Dictionary<string, int> veri_formdan_gelen = new Dictionary<string, int>();
                    for (int x = 0; x < sorular.Count; x++)
                    {
                        int secim = rnd.Next(1, 6);
                        if (temp == "")
                            temp += "(" + anket_no.ToString() + "," + sorular[x].ToString() + "," + i.ToString() + "," + Donem_ID + "," + secim.ToString() + ")";
                        else
                            temp += ", (" + anket_no.ToString() + "," + sorular[x].ToString() + "," + i.ToString() + "," + Donem_ID + "," + secim.ToString() + ")";

                        veri_formdan_gelen.Add("Soru_" + sorular[x].ToString(), secim);
                    }//sorular

                    //cnt_1++;
                    //cnt_2++;

                    #region Normalize edilmiş Indeksleme olmayan tablo
                    stopwatch_1.Restart();
                    conn = new MySqlConnection(cs);
                    cmd = new MySqlCommand(insert_sql_nor + temp, conn);
                    conn.Open();
                    //try
                    //{
                    eklenen_1 += cmd.ExecuteNonQuery();
                    //}
                    //catch
                    //{
                    //}

                    conn.Close();
                    stopwatch_1.Stop();
                    //her kayıt süresi, 100 ve 1000'lik durumlar dosyaya yazdırılıyor.
                    Dosya_Yaz("veri_tum_nor.txt", anket_no.ToString() + ", " + eklenen_1.ToString() + ", " + stopwatch_1.Elapsed.TotalMilliseconds.ToString());

                    //t_sure1_1 += stopwatch_1.Elapsed.TotalMilliseconds;
                    //t_kayit1_1 += eklenen_1;
                    //if (cnt_1 % 100 == 0)
                    //{
                    //    Dosya_Yaz("veri_100_nor.txt", t_kayit1_1.ToString() + ", " + t_sure1_1.ToString());
                    //    cnt_1 = 0;
                    //    t_sure1_1 = 0;
                    //    t_kayit1_1 = 0;
                    //}

                    //t_sure1_2 += stopwatch_1.Elapsed.TotalMilliseconds;
                    //t_kayit1_2 += eklenen_1;
                    //if (cnt_2 % 300 == 0)
                    //{
                    //    Dosya_Yaz("veri_300_nor.txt", t_kayit1_2.ToString() + ", " + t_sure1_2.ToString());
                    //    cnt_2 = 0;
                    //    t_sure1_2 = 0;
                    //    t_kayit1_2 = 0;
                    //}
                    #endregion

                    #region Normalize edilmiş Indeksleme olan tablo
                    stopwatch_2.Restart();
                    conn = new MySqlConnection(cs);
                    cmd = new MySqlCommand(insert_sql_nor_ind + temp, conn);
                    conn.Open();
                    //try
                    //{
                    eklenen_2 += cmd.ExecuteNonQuery();
                    //}
                    //catch
                    //{
                    //}

                    conn.Close();
                    stopwatch_2.Stop();
                    //her kayıt süresi, 100 ve 1000'lik durumlar dosyaya yazdırılıyor.
                    Dosya_Yaz("veri_tum_nor_ind.txt", anket_no.ToString() + ", " + eklenen_2.ToString() + ", " + stopwatch_2.Elapsed.TotalMilliseconds.ToString());

                    //t_sure2_1 += stopwatch_2.Elapsed.TotalMilliseconds;
                    //t_kayit2_1 += eklenen_2;
                    //if (cnt_1 % 100 == 0)
                    //{
                    //    Dosya_Yaz("veri_100_nor_ind.txt", t_kayit2_1.ToString() + ", " + t_sure2_1.ToString());
                    //    cnt_1 = 0;
                    //    t_sure2_1 = 0;
                    //    t_kayit2_1 = 0;
                    //}

                    //t_sure2_2 += stopwatch_2.Elapsed.TotalMilliseconds;
                    //t_kayit2_2 += eklenen_2;
                    //if (cnt_2 % 300 == 0)
                    //{
                    //    Dosya_Yaz("veri_300_nor_ind.txt", t_kayit2_2.ToString() + ", " + t_sure2_2.ToString());
                    //    cnt_2 = 0;
                    //    t_sure2_2 = 0;
                    //    t_kayit2_2 = 0;
                    //}
                    #endregion

                    #region Denormalizasyon
                    stopwatch_3.Restart();
                    string durum = "";
                    Guncelle_Anket_Rapor(anket_no.ToString(), i.ToString(), Donem_ID, veri_formdan_gelen, ref durum);

                    stopwatch_3.Stop();
                    //her kayıt süresi, 100 ve 1000'lik durumlar dosyaya yazdırılıyor.
                    Dosya_Yaz("veri_tum_denor.txt", anket_no.ToString() + ", " + durum + ", " + stopwatch_3.Elapsed.TotalMilliseconds.ToString());

                    //t_sure3_1 += stopwatch_3.Elapsed.TotalMilliseconds;
                    //t_kayit3_1 += 1;
                    //if (cnt_1 % 100 == 0)
                    //{
                    //    Dosya_Yaz("veri_100_denor.txt", t_kayit3_1.ToString() + ", " + t_sure3_1.ToString());
                    //    cnt_1 = 0;
                    //    t_sure3_1 = 0;
                    //    t_kayit3_1 = 0;
                    //}

                    //t_sure3_2 += stopwatch_3.Elapsed.TotalMilliseconds;
                    //t_kayit3_2 += 1;
                    //if (cnt_2 % 300 == 0)
                    //{
                    //    Dosya_Yaz("veri_300_denor.txt", t_kayit3_2.ToString() + ", " + t_sure3_2.ToString());
                    //    cnt_2 = 0;
                    //    t_sure3_2 = 0;
                    //    t_kayit3_2 = 0;
                    //}
                    #endregion
                }//for anket sayısı                
            }//ders sayısı 

             
        }

        private void sorgulama(int anket_no)
        {
            string select_sql_nor = "SELECT aii.SoruNo, AVG(Cevap) , MIN(Cevap) , MAX(Cevap) , STD(Cevap)  FROM anket_cevap_nor a INNER JOIN anket_icerik_iliski aii ON a.Anket_Icerik_ID = aii.Anket_Icerik_ID ";
            string select_sql_nor_ind = "SELECT aii.SoruNo, AVG(Cevap) , MIN(Cevap) , MAX(Cevap) , STD(Cevap)  FROM anket_cevap_nor_ind a INNER JOIN anket_icerik_iliski aii ON a.Anket_Icerik_ID = aii.Anket_Icerik_ID ";
            string Donem_ID = TXT_DonemID.Text;
            string[] _dersids = TXT_DersIDs.Text.Split('-');
            int ders_bas = Convert.ToInt32(_dersids[0]);
            int ders_bit = Convert.ToInt32(_dersids[1]);
            int anket_sayisi = Convert.ToInt32(TXT_AnketSayisi.Text);
            MySqlCommand cmd = null;
            MySqlDataReader _reader = null;
            Stopwatch stopwatch_1 = new Stopwatch();
            Stopwatch stopwatch_2 = new Stopwatch();
            Stopwatch stopwatch_3 = new Stopwatch();

            //Sonuçları hash tablosuna atalım, tüm test sonuçları aynı tabloya atılacak.
            Dictionary<string, Rapor_Sonuc> _sonuc = null;

                //ders aralığı kadar bir döngü açılıyor.
                for (int i = ders_bas; i <= ders_bit; i++)
                {
                    string temp = "WHERE a.Anket_ID=" + anket_no.ToString() + " AND a.Ders_ID=" + i.ToString() + " AND a.Donem_ID=" + Donem_ID + " GROUP BY a.Anket_Icerik_ID";

                    #region Normalize edilmiş Indeksleme olmayan tablo
                    stopwatch_1.Restart();
                    conn = new MySqlConnection(cs);
                    cmd = new MySqlCommand(select_sql_nor + temp, conn);
                    conn.Open();
                    _reader = cmd.ExecuteReader();
                    _sonuc = new Dictionary<string, Rapor_Sonuc>();
                    int alinan_1 = 0;
                    if (_reader.HasRows)
                    {
                        while (_reader.Read())
                        {
                            string soru_no = _reader.GetInt32(0).ToString();
                            if (!_sonuc.ContainsKey(soru_no))
                            {
                                Rapor_Sonuc _rs = new Rapor_Sonuc();
                                _rs.mean = _reader.GetDouble(1);
                                _rs.min = _reader.GetInt32(2);
                                _rs.max = _reader.GetInt32(3);
                                _rs.std = _reader.GetDouble(4);

                                _sonuc.Add(soru_no, _rs);
                                alinan_1++;
                            }
                        }
                    }
                    _reader.Close();
                    conn.Close();
                    stopwatch_1.Stop();
                    Dosya_Yaz("sorgu_tum_nor.txt", anket_no.ToString() + "," + alinan_1.ToString() + ", " + stopwatch_1.Elapsed.TotalMilliseconds.ToString());
                    #endregion

                    #region Normalize edilmiş Indeksleme olan tablo
                    stopwatch_2.Restart();
                    conn = new MySqlConnection(cs);
                    cmd = new MySqlCommand(select_sql_nor_ind + temp, conn);
                    conn.Open();
                    _reader = cmd.ExecuteReader();
                    _sonuc = new Dictionary<string, Rapor_Sonuc>();
                    int alinan_2 = 0;
                    if (_reader.HasRows)
                    {
                        while (_reader.Read())
                        {
                            string soru_no = _reader.GetInt32(0).ToString();
                            if (!_sonuc.ContainsKey(soru_no))
                            {
                                Rapor_Sonuc _rs = new Rapor_Sonuc();
                                _rs.mean = _reader.GetDouble(1);
                                _rs.min = _reader.GetInt32(2);
                                _rs.max = _reader.GetInt32(3);
                                _rs.std = _reader.GetDouble(4);

                                _sonuc.Add(soru_no, _rs);
                                alinan_2++;
                            }
                        }
                    }
                    _reader.Close();
                    conn.Close();
                    stopwatch_2.Stop();

                    //her kayıt süresi, 100 ve 1000'lik durumlar dosyaya yazdırılıyor.
                    Dosya_Yaz("sorgu_tum_nor_ind.txt", anket_no.ToString() + "," + alinan_2.ToString() + ", " + stopwatch_2.Elapsed.TotalMilliseconds.ToString());
                    #endregion

                    #region Denormalizasyon
                    stopwatch_3.Restart();
                    _sonuc = Ders_Raporu(anket_no.ToString(), i.ToString(), Donem_ID);
                    stopwatch_3.Stop();
                    int alinan_3 = _sonuc.Count;
                    //her kayıt süresi, 100 ve 1000'lik durumlar dosyaya yazdırılıyor.
                    Dosya_Yaz("sorgu_tum_denor.txt", anket_no.ToString() + "," + alinan_3.ToString() + ", " + stopwatch_3.Elapsed.TotalMilliseconds.ToString());
                    #endregion
                }//ders sayısı 
        }      
        #endregion
        
        #region Anket Soruları
        private List<string> Get_Anket_Soru(int Anket_ID)
        {
            List<string> _list = new List<string>();
            conn = new MySqlConnection(cs);
            conn.Open();
            MySqlCommand cmd = new MySqlCommand("SELECT Anket_Icerik_ID FROM anket_icerik_iliski WHERE Anket_ID=" + Anket_ID.ToString(), conn);
            MySqlDataReader _reader = cmd.ExecuteReader();
            while (_reader.Read())
            {
                _list.Add(_reader.GetInt32(0).ToString());
            }
            conn.Close();
            return _list;
        }
        #endregion

        #region Dosya İşlemleri
        private void Dosya_Yaz(string dosya_ismi, string veri)
        {
            using (StreamWriter w = File.AppendText(dosya_ismi))
            {
                w.WriteLine(veri);
            }
        }
        #endregion        

        #region Veritabanı işlemleri denormalizasyon
        private int Insert_Anket_Rapor(string Anket_ID, string Ders_ID, string Donem_ID, string Veri)
        {
            MySqlConnection _connect = new MySqlConnection(cs);
            _connect.Open();
            int _r = 0;
            string _sql = "INSERT INTO anket_cevap_denor (Anket_ID, Ders_ID, Donem_ID, Veri)";
            _sql += " VALUES ("+Anket_ID+","+Ders_ID+","+Donem_ID+", '"+Veri+"')";
            MySqlCommand _command = new MySqlCommand(_sql, _connect);
            try
            {
                _r = _command.ExecuteNonQuery();
            }
            catch
            {
                _r = -1;
            }

            _connect.Close();

            return _r;
        }

        private int Update_Anket_Rapor(string Anket_ID, string Ders_ID, string Donem_ID, string Veri)
        {
            MySqlConnection _connect = new MySqlConnection(cs);
            _connect.Open();
            int _r = 0;
            string _sql = "UPDATE anket_cevap_denor SET Veri='" + Veri + "' ";
            _sql += " WHERE Anket_ID="+Anket_ID+" AND Ders_ID="+Ders_ID+" AND Donem_ID="+Donem_ID;
            MySqlCommand _command = new MySqlCommand(_sql, _connect);
            try
            {
                _r = _command.ExecuteNonQuery();
            }
            catch
            {
                _r = -1;
            }

            _connect.Close();

            return _r;
        }

        private int Kontrol_Anket_Rapor(string Anket_ID, string Ders_ID, string Donem_ID)
        {
            int ID = 0;
            MySqlConnection _connect = new MySqlConnection(cs);
            string _sql = "SELECT count(*) FROM anket_cevap_denor ";
            _sql += " WHERE Anket_ID=" + Anket_ID + " AND Ders_ID=" + Ders_ID + " AND Donem_ID=" + Donem_ID;

            MySqlCommand _command = new MySqlCommand(_sql, _connect);
            _connect.Open();
            MySqlDataReader _reader = _command.ExecuteReader();

            if (_reader.HasRows)
            {
                _reader.Read();
                ID = _reader.GetInt32(0);
            }

            _connect.Close();

            return ID;
        }

        private string Get_Anket_Rapor(string Anket_ID, string Ders_ID, string Donem_ID)
        {
            MySqlConnection _connect = new MySqlConnection(cs);
            string _sql = "SELECT Veri FROM anket_cevap_denor ";
            _sql += " WHERE Anket_ID=" + Anket_ID + " AND Ders_ID=" + Ders_ID + " AND Donem_ID=" + Donem_ID;
            MySqlCommand _command = new MySqlCommand(_sql, _connect);
            _connect.Open();
            MySqlDataReader _reader = _command.ExecuteReader();

            string mevcut_veri = "";
            if (_reader.HasRows)
            {
                _reader.Read();
                mevcut_veri = _reader.GetString(0);
            }
            _reader.Close();
            _connect.Close();

            return mevcut_veri;
        }

        //Anketi kontrol et ve rapor bölümüne ya ilk eklemeyi yap ya da mevcut anketi güncelle.
        public bool Guncelle_Anket_Rapor(string Anket_ID, string Ders_ID, string Donem_ID, Dictionary<string, int> veri_formdan_gelen, ref string durum)
        {            
            int s = Kontrol_Anket_Rapor(Anket_ID, Ders_ID, Donem_ID);
            if (s == 0)
            {
                durum = "Insert";
                string veri = convert_veri_to_new_format(veri_formdan_gelen);
                Insert_Anket_Rapor(Anket_ID, Ders_ID, Donem_ID, veri);
            }
            else
            {
                durum = "Update";
                string mevcut_veri = Get_Anket_Rapor(Anket_ID, Ders_ID, Donem_ID);

                if (mevcut_veri != "")
                {
                    //mevcut veri içindeki sayısal değerleri al
                    Dictionary<string, string> _mevcut_dic = veri_coz_veritabanından_gelen_pure(mevcut_veri);
                    if (_mevcut_dic == null)
                        return false;
                    //dışarıdan gelen veri
                    Dictionary<string, int> _gelen_dic = veri_formdan_gelen; 
                    if (_gelen_dic == null)
                        return false;

                    //anahtar listesi
                    List<string> list = new List<string>(_gelen_dic.Keys);
                    string veri_temp = "";
                    //Soru_1_0=5-2,4-1&Soru_1_1=4-1&Soru_2_0=3-2,2-1&Soru_2_1=3-3,3-4
                    foreach (string k in list)
                    {
                        //içermesi beklenir.(Sorular tam anket ortasında değiştirilirse içermeyebilir. Böyle bir durum beklenmiyor.)
                        if (_mevcut_dic.ContainsKey(k))
                        {
                            //5-2,4-1
                            string temp_str = _mevcut_dic[k];
                            int gelen_int = _gelen_dic[k];
                            if (temp_str.Contains(gelen_int.ToString() + "-"))
                            {
                                int baslangic = temp_str.IndexOf(gelen_int.ToString() + "-") + (gelen_int.ToString() + "-").Length;
                                int bitis = temp_str.Substring(baslangic).IndexOf(",");
                                if (bitis == -1)
                                    bitis = temp_str.Substring(baslangic).Length;
                                string eski_int = temp_str.Substring(baslangic, bitis);

                                temp_str = temp_str.Replace(gelen_int.ToString() + "-" + eski_int, gelen_int.ToString() + "-" + (Convert.ToInt32(eski_int) + 1).ToString());
                            }
                            else
                                temp_str = temp_str + "," + gelen_int.ToString() + "-1"; //ekleniyor


                            if (veri_temp == "")
                                veri_temp = k + "=" + temp_str;
                            else
                                veri_temp += "&" + k + "=" + temp_str;
                        }
                    }

                    Update_Anket_Rapor(Anket_ID, Ders_ID, Donem_ID, veri_temp);
                }
            }
            return true;
        }


        #endregion

        #region Anket_Raporlama
        //Derslere ait bilgilerin dökümü
        private Dictionary<string, Dictionary<int, int>> Ders_Raporu_Get(string Anket_ID, string Ders_ID, string Donem_ID)
        {
            string veri = Get_Anket_Rapor(Anket_ID, Ders_ID, Donem_ID);

            return veri_coz_veritabanından_gelen(veri); //tüm sonuçlar dictionary yapısı içinde
        }

        //Derslere ait bilgilerin dökümü
        public Dictionary<string, Rapor_Sonuc> Ders_Raporu(string Anket_ID, string Ders_ID, string Donem_ID)
        {
            Dictionary<string, Rapor_Sonuc> _dic_sonuc = new Dictionary<string, Rapor_Sonuc>();
            Dictionary<string, Dictionary<int, int>> _dic_rapor = Ders_Raporu_Get(Anket_ID, Ders_ID, Donem_ID);
            if (_dic_rapor == null)
                return null; //ankette hiç bir öğrenci işaretleme yapmamış.
            List<string> list = new List<string>(_dic_rapor.Keys);
            foreach (string k in list)
            {
                Dictionary<int, int> _dic_ic = _dic_rapor[k];
                if (_dic_ic != null)
                {
                    List<int> list_ic = new List<int>(_dic_ic.Keys);
                    Rapor_Sonuc _rs = new Rapor_Sonuc();
                    int toplam = 0;
                    foreach (int item in list_ic)
                    {
                        if (_rs.min > item)
                            _rs.min = item;
                        if (_rs.max < item)
                            _rs.max = item;
                        toplam += item * _dic_ic[item];
                        _rs.oy_sayisi += _dic_ic[item];
                    }

                    _rs.mean = (double)toplam / _rs.oy_sayisi;
                    _rs.std = 0;
                    foreach (int item in list_ic)
                        _rs.std += _dic_ic[item] * (item - _rs.mean) * (item - _rs.mean);

                    _rs.std = Math.Sqrt(_rs.std / _rs.oy_sayisi);
                    //tekrar olmaması lazım ama yine de kontrol olsun
                    if (!_dic_sonuc.ContainsKey(k))
                        _dic_sonuc.Add(k, _rs);
                }
                else
                {
                    Rapor_Sonuc _rs = new Rapor_Sonuc();
                    if (!_dic_sonuc.ContainsKey(k))
                        _dic_sonuc.Add(k, _rs);
                }

            }

            return _dic_sonuc;
        }
        #endregion

        #region Anket_Veri_Çözme_Fonksiyonları
        //arama hızlı olsun diye
        private Dictionary<string, int> veri_coz_formdan_gelen(string veri)
        {
            //Soru_1_0=5&Soru_1_1=4&Soru_2_0=3&Soru_2=3
            Dictionary<string, int> _sonuc_dic = new Dictionary<string, int>();
            foreach (string _str in veri.Split('&'))
            {
                if (_str.Contains("="))
                {
                    try
                    {
                        string[] temp = _str.Split('=');
                        if (!_sonuc_dic.ContainsKey(temp[0]))
                            _sonuc_dic.Add(temp[0], Convert.ToInt32(temp[1]));
                    }
                    catch
                    {
                        return null;
                    }
                }//garanti olsun
            }

            return _sonuc_dic;
        }

        private string convert_veri_to_new_format(Dictionary<string, int> _dic)
        {
            string temp = "";
            List<string> list = new List<string>(_dic.Keys);
            foreach (string k in list)
            {
                if (temp == "")
                    temp = k + "=" + ((int)_dic[k]).ToString() + "-1";
                else
                    temp += "&" + k + "=" + ((int)_dic[k]).ToString() + "-1";
            }

            return temp;
        }

        //değişiklik için string kısmında değişiklik yapmak için
        private Dictionary<string, string> veri_coz_veritabanından_gelen_pure(string veri)
        {
            //Soru_1_0=5-2,4-1&Soru_1_1=4-1&Soru_2_0=3-2,2-1&Soru_2_1=3-3,3-4
            Dictionary<string, string> _sonuc_dic = new Dictionary<string, string>();
            foreach (string _str in veri.Split('&'))
            {
                if (_str.Contains("="))
                {
                    try
                    {
                        string[] temp = _str.Split('=');
                        if (!_sonuc_dic.ContainsKey(temp[0]))
                            _sonuc_dic.Add(temp[0], temp[1]);
                    }
                    catch
                    {
                        return null;
                    }
                }//garanti olsun
            }

            return _sonuc_dic;
        }
        //raporlama için
        private Dictionary<string, Dictionary<int, int>> veri_coz_veritabanından_gelen(string veri)
        {
            //Soru_1_0=5-2,4-1&Soru_1_1=4-1&Soru_2_0=3-2,2-1&Soru_2_1=3-3,3-4
            Dictionary<string, Dictionary<int, int>> _sonuc_dic = new Dictionary<string, Dictionary<int, int>>();
            foreach (string _str in veri.Split('&'))
            {
                if (_str.Contains("="))
                {
                    try
                    {
                        string[] temp = _str.Split('=');
                        Dictionary<int, int> _ic_sonuc = new Dictionary<int, int>();
                        if (!_sonuc_dic.ContainsKey(temp[0]))
                        {
                            if (temp[1].Contains(','))
                            {
                                string[] temp_inner = temp[1].Split(',');
                                foreach (string item in temp_inner)
                                {
                                    string[] temp_sonuc = item.Split('-');
                                    if (!_ic_sonuc.ContainsKey(Convert.ToInt32(temp_sonuc[0])))
                                        _ic_sonuc.Add(Convert.ToInt32(temp_sonuc[0]), Convert.ToInt32(temp_sonuc[1]));
                                }
                            }
                            else //tek sonuç var, virgüllü kısım yok
                            {
                                string[] temp_sonuc = temp[1].Split('-');
                                if (!_ic_sonuc.ContainsKey(Convert.ToInt32(temp_sonuc[0])))
                                    _ic_sonuc.Add(Convert.ToInt32(temp_sonuc[0]), Convert.ToInt32(temp_sonuc[1]));
                            }


                            if (!_sonuc_dic.ContainsKey(temp[0]))
                                _sonuc_dic.Add(temp[0], _ic_sonuc);
                        }

                    }
                    catch
                    {
                        return null;
                    }
                }//garanti olsun
            }

            return _sonuc_dic;
        }
        #endregion
    }

    public class Rapor_Sonuc
    {
        public int min;
        public int max;
        public double std;
        public double mean;
        public int oy_sayisi;

        public Rapor_Sonuc()
        {
            min = 10;
            max = 0;
            std = 0;
            mean = 0;
            oy_sayisi = 0;
        }
    }
}
