-- phpMyAdmin SQL Dump
-- version 4.0.9
-- http://www.phpmyadmin.net
--
-- Anamakine: 127.0.0.1
-- Üretim Zamanı: 25 Tem 2016, 09:19:12
-- Sunucu sürümü: 5.6.14
-- PHP Sürümü: 5.5.6

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Veritabanı: `anket`
--

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket`
--

CREATE TABLE IF NOT EXISTS `anket` (
  `Anket_ID` int(11) NOT NULL AUTO_INCREMENT,
  `Anket_Adi` varchar(50) NOT NULL,
  `Bas_Tarih` datetime NOT NULL,
  `Bit_Tarih` datetime NOT NULL,
  `Bolum_ID` int(11) NOT NULL,
  PRIMARY KEY (`Anket_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin5 AUTO_INCREMENT=9 ;

--
-- Tablo döküm verisi `anket`
--

INSERT INTO `anket` (`Anket_ID`, `Anket_Adi`, `Bas_Tarih`, `Bit_Tarih`, `Bolum_ID`) VALUES
(1, 'Bilgisayar Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 21),
(2, 'Biyomedikal Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 22),
(3, 'Çevre Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 23),
(4, 'Elektronik ve Haberleşme Mühendisliği Mühendisliği', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 25),
(5, 'İnşaat Mühendisliği Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 27),
(6, 'Makine Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 28),
(7, 'Tekstil Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 30),
(8, 'Endüstri Mühendisliği Öğrenci Anketi', '2016-06-01 00:00:00', '2016-06-30 00:00:00', 538);

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket_cevap_denor`
--

CREATE TABLE IF NOT EXISTS `anket_cevap_denor` (
  `Anket_ID` int(11) NOT NULL,
  `Ders_ID` int(11) NOT NULL,
  `Donem_ID` int(11) NOT NULL,
  `Veri` varchar(1000) CHARACTER SET latin5 NOT NULL,
  PRIMARY KEY (`Anket_ID`,`Ders_ID`,`Donem_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket_cevap_nor`
--

CREATE TABLE IF NOT EXISTS `anket_cevap_nor` (
  `Cevap_ID` bigint(11) NOT NULL AUTO_INCREMENT,
  `Anket_ID` int(11) NOT NULL,
  `Anket_Icerik_ID` int(11) NOT NULL,
  `Ders_ID` int(11) NOT NULL,
  `Donem_ID` int(11) NOT NULL,
  `Cevap` int(11) NOT NULL,
  PRIMARY KEY (`Cevap_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket_cevap_nor_ind`
--

CREATE TABLE IF NOT EXISTS `anket_cevap_nor_ind` (
  `Cevap_ID` bigint(11) NOT NULL AUTO_INCREMENT,
  `Anket_ID` int(11) NOT NULL,
  `Anket_Icerik_ID` int(11) NOT NULL,
  `Ders_ID` int(11) NOT NULL,
  `Donem_ID` int(11) NOT NULL,
  `Cevap` int(11) NOT NULL,
  PRIMARY KEY (`Cevap_ID`),
  KEY `Anket_Icerik_ID` (`Anket_Icerik_ID`),
  KEY `Ders_ID` (`Anket_ID`,`Ders_ID`,`Donem_ID`),
  KEY `Cevap` (`Cevap`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket_icerik`
--

CREATE TABLE IF NOT EXISTS `anket_icerik` (
  `Anket_Icerik_ID` int(11) NOT NULL AUTO_INCREMENT,
  `Icerik` varchar(500) CHARACTER SET latin5 NOT NULL,
  `GrupNo` int(11) NOT NULL,
  PRIMARY KEY (`Anket_Icerik_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=56 ;

--
-- Tablo döküm verisi `anket_icerik`
--

INSERT INTO `anket_icerik` (`Anket_Icerik_ID`, `Icerik`, `GrupNo`) VALUES
(1, 'Derse düzenli ve zamanında gelir.', 1),
(2, 'Derse düzenli ve zamanında gelir.', 1),
(3, 'Derse hazırlıklı gelir.', 1),
(4, 'Dersleri öğrencileri etkin kılacak, katılımlarını sağlayacak biçimde işler.', 1),
(5, 'Öğrenmeyi destekleyecek sınıf dışı etkinlikleri (ödev, proje, görüşme, gözlem, tarama vb) etkili kullanır.', 1),
(6, 'Sorulara açık, net ve tatminkâr cevaplar verir.', 1),
(7, 'Öğrencilerin öğrenme düzeylerini uygun tekniklerle ölçer ve objektif biçimde değerlendirir.', 1),
(8, 'Ders saatleri dışında erişmek kolaydır ve öğrencilere yeterli zaman ayırır.', 1),
(9, 'Etkili iletişim becerisine sahiptir ve öğrencilerle olumlu ilişkiler kurar.', 1),
(10, 'Sınıf içi hâkimiyeti yüksektir.', 1),
(11, 'Dersle ilgili kaynaklar yeterlidir.', 2),
(12, 'Dersin içeriği bölüme uygun olarak yapılandırılmış', 2),
(13, 'Dersin mesleki gelişimime katkısı yüksektir.', 2),
(14, 'Ders içeriği ile ders saati uyumludur.', 2),
(15, 'Dersin uygulaması ve/veya ödevleri yeterlidir.', 2),
(16, 'Analitik düşünce ile bir sistemi, sistem bileşenini ya da süreci analiz etme ve istenen gereksinimleri karşılamak üzere gerçekçi kısıtlar altında tasarlama becerisi; bu doğrultuda modern tasarım yöntemlerini inceleme, iyileştirme ve geliştirmeye yönelik algoritmik çözümler üretebilme becerisine katkısı yüksektir.', 3),
(17, 'Bilgiye erişebilme ve bu amaçla kaynak araştırması yapabilme, veri tabanları ve diğer bilgi kaynaklarını kullanabilme becerisine katkısı yüksektir.', 3),
(18, 'Mühendislik uygulamaları için gerekli olan donanım ve yazılımları kullanma becerisine katkısı  yüksektir.', 3),
(19, 'Temel bilimleri Bilgisayar Mühendisliği alanında kullanma becerisine katkısı yüksektir.', 3),
(20, 'Yaşam boyu öğrenmenin gerekliliği bilinci; bilişim ve teknolojideki gelişmeleri izleme ve kendini sürekli yenileme becerisine katkısı yüksektir.', 3),
(21, 'Biyomedikal mühendisliği alanında toplumsal ihtiyaçlar doğrultusunda problem tanımlayabilme ve bunlara dönük çözümler geliştirebilme becerisine katkısı yüksektir.', 3),
(22, 'Biyomedikal mühendisliğine ilişkin deney tasarlama, deney yapma ve deney sonuçlarını analiz etme ve yorumlama  becerisine katkısı yüksektir.', 3),
(23, 'Biyomedikal mühendislik faaliyetinin yürütülmesinde kullanılan alet ve cihazlar hakkında kapsamlı bir bilgi sahibi olma ve bu bilgiyi sürekli güncelleyebilme  becerisine katkısı yüksektir.', 3),
(24, 'Matematik, fizik, biyoloji, kimya gibi temel bilim alanlarında edindiği bilgi ve birikimi mühendislik yöntemleriyle birleştirebilme  becerisine katkısı yüksektir.', 3),
(25, 'Sürekli kendini geliştirme, yenilikleri takip edebilme  becerisine katkısı yüksektir.', 3),
(26, 'Çevre Mühendisliği Mesleki, etik ve sosyal sorumluluk bilinci kazandırması iyidir.', 3),
(27, 'Küresel ve yerel ölçekli çevre problemlerine duyarlılık kazandırması iyidir.', 3),
(28, 'Mühendislik çözümlerinin, evrensel ve toplumsal boyutlardaki etkilerini anlayabilmek için yeterli eğitim düzeyine ulaşmaya katkısı yüksektir.', 3),
(29, 'Su, atıksu, hava kirliliği, altyapı vb. Çevre Mühendisliği konularında istenilen bir sistemi, parçayı ya da süreci tasarlama becerisine katkısı yüksektir.', 3),
(30, 'Temel Bilimleri (Matematik, fen) Çevre Mühendisliği tasarımlarında kullanabilmeye katkısı yüksektir.', 3),
(31, 'Disiplin içi ve disiplinler arası takım çalışması yapabilme becerisi yüksektir.', 3),
(32, 'Elektronik ve Haberleşme Mühendisliği ve ilgili alanlarda mühendislik problemlerini tanımlama, modelleme ve çözme becerisi yüksektir.', 3),
(33, 'Gerektiğinde tek başına mesleğinde araştırma yapabilme, inisiyatif kullanma ve yaratıcılık becerisi yüksektir.', 3),
(34, 'Mühendislik uygulamaları için gerekli çağdaş teknikleri ve hesaplama araçlarını kullanabilme becerisi yüksektir.', 3),
(35, 'Verilerin çözümlenmesi, deney yapma ve tasarlama, sonuçları yorumlama becerisi yüksektir.', 3),
(36, 'Bilgiye erişmek ve bu amaçla kaynak araştırması yapmak, veri tabanları ve diğer bilgi kaynaklarını kullanmak alanlarında katkısı yüksektir.', 3),
(37, 'Endüstri Mühendisliği alanında elde ettikleri bilgi ve çözüm yöntemlerini disiplinler arası çalışmalarda uygulayabilme becerisine sahip olmaya katkısı yüksektir.', 3),
(38, 'Endüstri Mühendisliği uygulamaları için gerekli modern teknik ve araçları geliştirme, seçme ve kullanma yetkinliğine ve bilişim teknolojilerini etkin bir şekilde kullanma yetkinliğine sahip olmaya katkısı yüksektir.', 3),
(39, 'Karmaşık Endüstri Mühendisliği problemlerini saptama, tanımlama, formüle etme ve çözme becerisi ve bu amaca uygun olarak analiz ve modelleme yöntemlerini seçme ve uygulama becerisine sahip olmaya katkısı yüksektir.', 3),
(40, 'Matematik, Fen Bilimleri ve Endüstri Mühendisliği konularında yeterli bilgi birikimini ve bu alanlardaki kuramsal ve uygulamalı bilgilerini, mühendislik problemlerini modelleme ve çözme için uygulayabilme becerisine sahip olmaya katkısı yüksektir.', 3),
(41, 'Gözlem ve deney tasarlama, yapma ve bunların sonuçlarını değerlendirme, çözümleme ve yorumlama becerisine katkısı yüksektir.', 3),
(42, 'Matematik, fizik, kimya, biyoloji ve genelde temel mühendislik bilgilerini uygulama yeti ve becerisine katkısı yüksektir.', 3),
(43, 'Mühendislik çözümlemelerinin, evrensel ve toplumsal boyutlardaki etkilerini anlamak için gerekli genişlikte eğitim almaya katkısı yüksektir.', 3),
(44, 'Mühendislik problemlerini tanımlama, ifade etme ve çözme becerisine katkısı yüksektir.', 3),
(45, 'Mühendislik uygulamaları için gerekli olan yöntemleri ve çağdaş araçları kullanma becerisine katkısı yüksektir.', 3),
(46, 'Bir sistemi, sistem bileşenini ya da süreci analiz etme ve istenen gereksinimleri karşılamak üzere gerçekçi kısıtlar altında tasarlama becerisi; bu doğrultuda modern tasarım yöntemlerini uygulama becerisi kazandırmaya katkısı yüksektir.', 3),
(47, 'Deney tasarlama, deney yapma, veri toplama, sonuçları analiz etme ve yorumlama becerisine katkısı yüksektir.', 3),
(48, 'Karmaşık mühendislik problemlerini belirleme, tanımlama, formüle etme ve çözme becerisi; bu amaçla uygun analitik yöntemler ve modelleme tekniklerini seçme ve uygulama becerisine katkısı yüksektir.', 3),
(49, 'Matematik, Fen Bilimleri ve Makine Mühendisliği konularında yeterli altyapıya sahip olma; bu alanlardaki kuramsal ve uygulamalı bilgileri mühendislik çözümlerinde kullanabilme becerisine katkısı yüksektir.', 3),
(50, 'Uzman ya da uzman olmayan dinleyici gruplarını mühendislik problemleri ve çözüm önerileri ile ilgili konularda yazılı ve sözlü olarak bilgilendirme becerisine katkısı yüksektir.', 3),
(51, 'Deney ve proje tasarlama, gerçekleştirme ve sonuçlarını çözümleyip değerlendirebilme ve yorumlama becerisine katkısı yüksektir.', 3),
(52, 'Tekstil hammaddelerini ve malzemelerini tanıma ve özellikleri hakkında bilgi sahibi olma becerisine katkısı yüksektir.', 3),
(53, 'Tekstil üretim süreçlerini ve parametrelerini kavrama ve amaca uygun bir şekilde tasarlayıp, gerçekleştirebilme becerisine katkısı yüksektir.', 3),
(54, 'Temel Bilimlerde sağlam bilgiye sahip olma ve karşılaştığı mesleki problemlerin çözümünde bunları kullanabilme becerisine katkısı yüksektir.', 3),
(55, 'Temel mühendislik kavramlarına hâkim olma, analitik düşünme ve problem çözme yeteneğine sahip olma  becerisine katkısı yüksektir.', 3);

-- --------------------------------------------------------

--
-- Tablo için tablo yapısı `anket_icerik_iliski`
--

CREATE TABLE IF NOT EXISTS `anket_icerik_iliski` (
  `Anket_ID` int(11) NOT NULL,
  `Anket_Icerik_ID` int(11) NOT NULL,
  `SoruNo` int(11) NOT NULL,
  PRIMARY KEY (`Anket_ID`,`Anket_Icerik_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Tablo döküm verisi `anket_icerik_iliski`
--

INSERT INTO `anket_icerik_iliski` (`Anket_ID`, `Anket_Icerik_ID`, `SoruNo`) VALUES
(1, 1, 1),
(1, 2, 2),
(1, 3, 3),
(1, 4, 4),
(1, 5, 5),
(1, 6, 6),
(1, 7, 7),
(1, 8, 8),
(1, 9, 9),
(1, 10, 10),
(1, 11, 11),
(1, 12, 12),
(1, 13, 13),
(1, 14, 14),
(1, 15, 15),
(1, 16, 16),
(1, 17, 17),
(1, 18, 18),
(1, 19, 19),
(1, 20, 20),
(2, 1, 1),
(2, 2, 2),
(2, 3, 3),
(2, 4, 4),
(2, 5, 5),
(2, 6, 6),
(2, 7, 7),
(2, 8, 8),
(2, 9, 9),
(2, 10, 10),
(2, 11, 11),
(2, 12, 12),
(2, 13, 13),
(2, 14, 14),
(2, 15, 15),
(2, 21, 16),
(2, 22, 17),
(2, 23, 18),
(2, 24, 19),
(2, 25, 20),
(3, 1, 1),
(3, 2, 2),
(3, 3, 3),
(3, 4, 4),
(3, 5, 5),
(3, 6, 6),
(3, 7, 7),
(3, 8, 8),
(3, 9, 9),
(3, 10, 10),
(3, 11, 11),
(3, 12, 12),
(3, 13, 13),
(3, 14, 14),
(3, 15, 15),
(3, 26, 16),
(3, 27, 17),
(3, 28, 18),
(3, 29, 19),
(3, 30, 20),
(4, 1, 1),
(4, 2, 2),
(4, 3, 3),
(4, 4, 4),
(4, 5, 5),
(4, 6, 6),
(4, 7, 7),
(4, 8, 8),
(4, 9, 9),
(4, 10, 10),
(4, 11, 11),
(4, 12, 12),
(4, 13, 13),
(4, 14, 14),
(4, 15, 15),
(4, 31, 16),
(4, 32, 17),
(4, 33, 18),
(4, 34, 19),
(4, 35, 20),
(5, 1, 1),
(5, 2, 2),
(5, 3, 3),
(5, 4, 4),
(5, 5, 5),
(5, 6, 6),
(5, 7, 7),
(5, 8, 8),
(5, 9, 9),
(5, 10, 10),
(5, 11, 11),
(5, 12, 12),
(5, 13, 13),
(5, 14, 14),
(5, 15, 15),
(5, 41, 16),
(5, 42, 17),
(5, 43, 18),
(5, 44, 19),
(5, 45, 20),
(6, 1, 1),
(6, 2, 2),
(6, 3, 3),
(6, 4, 4),
(6, 5, 5),
(6, 6, 6),
(6, 7, 7),
(6, 8, 8),
(6, 9, 9),
(6, 10, 10),
(6, 11, 11),
(6, 12, 12),
(6, 13, 13),
(6, 14, 14),
(6, 15, 15),
(6, 46, 16),
(6, 47, 17),
(6, 48, 18),
(6, 49, 19),
(6, 50, 20),
(7, 1, 1),
(7, 2, 2),
(7, 3, 3),
(7, 4, 4),
(7, 5, 5),
(7, 6, 6),
(7, 7, 7),
(7, 8, 8),
(7, 9, 9),
(7, 10, 10),
(7, 11, 11),
(7, 12, 12),
(7, 13, 13),
(7, 14, 14),
(7, 15, 15),
(7, 51, 16),
(7, 52, 17),
(7, 53, 18),
(7, 54, 19),
(7, 55, 20),
(8, 1, 1),
(8, 2, 2),
(8, 3, 3),
(8, 4, 4),
(8, 5, 5),
(8, 6, 6),
(8, 7, 7),
(8, 8, 8),
(8, 9, 9),
(8, 10, 10),
(8, 11, 11),
(8, 12, 12),
(8, 13, 13),
(8, 14, 14),
(8, 15, 15),
(8, 36, 16),
(8, 37, 17),
(8, 38, 18),
(8, 39, 19),
(8, 40, 20);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
